#if !defined(SGI_CC)
#include <string>
#include <complex>
#else
#include <mstring.h>
#include <complex.h>
#endif

#include "btl/PIRProcessor.h"
#include "btl/AminoAcidProperty.h"
#include "btl/FFT.h"
#include <iomanip.h>
#include <algo.h>

int main(int argc, char* argv[])
{
    if (argc != 2)
    {
        cerr << "Usage: FFT_1D_Demo inputPIRFile" << endl;
        exit(1);
    }
    
    BTL_PIRProcessor p;
    p.ReadFile(argv[1]);
    if (p.empty())
    	exit(1);
    	
    string seq = p.Seq(0);
    if (seq.empty())
    	exit(1);
    unsigned int size = seq.size();
   
    typedef vector< complex<double> > Container;
    Container hseq(size);
    

    BTL_AminoAcidProperty hpath(KyteHydropathy);
    transform(seq.begin(), seq.end(), hseq.begin(), hpath);

    Container hseqt(size);
    BTL_FFT<Container::iterator>::Transform(hseq.begin(),hseqt.begin(),size);
    
    cout.setf(ios::showpoint);
    cout.setf(ios::fixed, ios::floatfield);
    for (unsigned int i=0; i<size; i++)
    	cout << setw(10) << setprecision(4) 
	     << norm(hseq[i]) << " " << norm(hseqt[i]) << '\n';
    	
    return 0;
}
