

// Test Cholesky module

#include <iostream.h>

#include "tnt.h"
#include "vec.h"
//#include "cmat.h"
#include "btl/Matrix.h"
#include "cholesky.h"
#include "trislv.h"
#include "transv.h"         /* tranpose views */

main()
{
    BTL_Matrix A(10,10);
    typedef BTL_Matrix::size_type Subscript;

    cin >> A;

    Subscript N = A.num_rows();
    assert(N == A.num_cols());

    BTL_Vector b(N, 1.0);   // b= [1,1,1,...]
    
    BTL_Matrix L(N, N);

    cerr << "A: " << A << endl;
   
    if (Cholesky_upper_factorization(A, L) !=0)
    {
        cerr << "Cholesky did not work." << endl;
        exit(1);
    }

    cerr << L << endl;

    // solve Ax =b, as L*L'x =b
    //
    //  let y=L'x, then
    //
    //
    //   solve L y = b;
    //   solve L'x = y;

    BTL_Vector y = Lower_triangular_solve(L, b);
    
    BTL_Vector x = Upper_triangular_solve(L.Transpose(), y);

    cerr << "x: " << x << endl;
    cerr << "Residual A*x-b: " << A*x-b << endl;
}
